/*******************************************************************************
*  skSDfileio.c | fileioĝׂrcJ[hpCu                      *
*                                                                              *
*    SD_Initialize  - rcJ[h̏s                             *
*    SD_Termination - rcJ[h̏I쏈                                 *
*    SD_fGets       - t@CPsǂݍޏ                             *
*                                                                              *
*  FMLAframeworkfileioCuL̂łgpׂ̊֐WB  *
*        framework̃o[W"v2016_11_7"ō쐬܂B                   *
*        fileioCu͖32-36KbytevO܂B        *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2017-02-12  ޒH[(ނ)  Create                            *
*  2.00    2019-05-22  ޒH[(ނ)  SD_Initialize()֐ύX       *
* ============================================================================ *
*  PIC 18F26K22 24EP256MC202 24FJ64GB002                                       *
*  ̑PIC18/24np\Ǝv܂B                                *
*  MPLAB X(v3.50)                                                              *
*  MPLAB(R) XC8  C Compiler Version 1.40                                       *
*  MPLAB(R) XC16 C Compiler Version 1.30                                       *
*******************************************************************************/
#include <XC.h>
#include "skSDfileio.h"

/*******************************************************************************
gSDDrive\̂gpƁA
FILEIOCuhCuƂ̃C^tF[XɎgphCot@NṼZbg
wo܂B
[U[w肳ꂽhCuɃANZXꍇ́A̍\ێKvL܂B
*******************************************************************************/
const FILEIO_DRIVE_CONFIG gSdDrive = {
    (FILEIO_DRIVER_IOInitialize)FILEIO_SD_IOInitialize,                 // hCogpI / Os֐
    (FILEIO_DRIVER_MediaDetect)FILEIO_SD_MediaDetect,                   // fBA}ꂽƂo֐
    (FILEIO_DRIVER_MediaInitialize)FILEIO_SD_MediaInitialize,           // fBA֐
    (FILEIO_DRIVER_MediaDeinitialize)FILEIO_SD_MediaDeinitialize,       // fBȀ֐
    (FILEIO_DRIVER_SectorRead)FILEIO_SD_SectorRead,                     // fBAZN^ǂݎ֐
    (FILEIO_DRIVER_SectorWrite)FILEIO_SD_SectorWrite,                   // fBAɃZN^ފ֐
    (FILEIO_DRIVER_WriteProtectStateGet)FILEIO_SD_WriteProtectStateGet, // fBÃCgveNgԂo֐
} ;


/*******************************************************************************
*  ans = SD_Initialize(driveId)                                                *
*    rcJ[h̏s                                              *
*                                                                              *
*    char driveId         F 1̃hCuIDw肵܂ ('A'-'Z')           *
*    SDINIT_ERROR_TYPE ans : I= SDINIT_ERROR_NONE(0)                    *
*                            ُI= 0ȊO̴װޒl("skSDfileio.h"Q)  *
*******************************************************************************/
SDINIT_ERROR_TYPE SD_Initialize(char driveId)
{
     SDINIT_ERROR_TYPE ret = SDINIT_ERROR_NONE ;
     FILEIO_ERROR_TYPE ans ;

     // fileioCȕs
     if (FILEIO_Initialize()) {
          // SDJ[hSPI100`400KHzʐMxōslɂ
#if defined (__XC8__)
          // Ȃ̂ŁAAPLLEN=1Ȃ"4x"NbNOďAĂPLLEN=1ƂB
          // APLLEN=1ɂ́A"system.h""SYS_CLK_FrequencySystemGet( )"l
          // "4x"OCPUNbNlݒ肷B
          int pllen = OSCTUNEbits.PLLEN ;
          OSCTUNEbits.PLLEN = 0 ;
#endif
          // SDJ[h\Pbgɑ}Ă邩ׂ
          if (FILEIO_MediaDetect(&gSdDrive, &sdCardMediaParameters) == true) {
               // SDJ[hhCo[̃}Egs
               ans = FILEIO_DriveMount(driveId, &gSdDrive, &sdCardMediaParameters) ;
               if (ans != FILEIO_ERROR_NONE) ret = SDINIT_ERROR_NO_MOUNT ;
          } else ret = SDINIT_ERROR_NO_CARD ;
#if defined (__XC8__)
          OSCTUNEbits.PLLEN = pllen ;
#endif
     } else ret = SDINIT_ERROR_FILEIO_INIT ;

     return ret ;
}
/*******************************************************************************
*  ans = SD_Termination(driveId)                                               *
*    rcJ[h̏I쏈                                                  *
*                                                                              *
*    char driveId           F1̃hCuIDw肵܂ ('A'-'Z')          *
*    FILEIO_ERROR_TYPE ans  : FILEIO_ERROR_TYPEԂ܂B                    *
*******************************************************************************/
FILEIO_ERROR_TYPE SD_Termination(char driveId)
{
     FILEIO_ERROR_TYPE ret ;

     // ݂̃t@CG[ǂݎ肻̂܂ܕԂ
     ret = FILEIO_ErrorGet(driveId) ;
     // hCũA}Egs
     // hCugpJĂt@CSĕ悤ɂ݂܂
     //iȂƂ蓖Ă܂jB
     FILEIO_DriveUnmount(driveId) ;

     return ret ;
}
/*******************************************************************************
*  ans = SD_fGets(*buffer,nbyte,*fp)                                           *
*    t@CPsǂݍޏ                                              *
*    0x0a(LF)ɏo܂œǂ݂܂Anbyte܂œǂݍ݂܂B             *
*    bufferɂ́A0x0d(CR)/0x0a(LF)Rs[܂Aobt@TCYɒӂłB *
*    FILEIO_Read֐1bytePʂœǂݏoĂ̂őxIɂ͒xȂ܂B    *
*                                                                              *
*    char *buffer     Fǂݍ񂾃f[^̊i[ob t@̃|C^w      *
*    size_t nbyte     : Ǎރf[^̃oCgw肵܂                     *
*    FILEIO_OBJECT *fpFt@CIuWFNgւ̃| C^                      *
*    int ans          FI=I͓ǂݍ񂾃oCgԂ܂    *
*                       ُI=|P(FILEIO_RESULT_FAILURE)                   *
*******************************************************************************/
int SD_fGets(char *buffer,size_t nbyte,FILEIO_OBJECT *fp)
{
     int  t ;
     char c ;

     t = 0 ;
     do {
          if (FILEIO_Read(&c, 1, 1, fp) == 1) {
               *buffer = c ;
               buffer++ ;
               t++ ;
          } else return FILEIO_RESULT_FAILURE ;
          // 0x0a(LF)ȂIA͎woCgǂ񂾂I
          if (c == 0x0A) break ;
     } while(t < nbyte) ;

     return t ;
}
