/********************************************************************
 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the "Company") for its PIC(R) Microcontroller is intended and
 supplied to you, the Company's customer, for use solely and
 exclusively on Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

* ============================================================================ *
*   VERSION DATE       BY                   CHANGE/COMMENT                     *
* ---------------------------------------------------------------------------- *
*   1.00    2017-02-11 ޒH[(ނ) 18F26K22pɏ쐬           *
*                                                                              *
* ---------------------------------------------------------------------------- *
*  PIC 18F26K22(fileioCu36KBytevO)         *
*  MPLAB X(v3.50)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.40                                        *
* ============================================================================ *

 *******************************************************************/

#include <xc.h>
#include <stdbool.h>
#include "system_config.h"
#include "system.h"
#include "sd_spi.h"

// J[h}m̔zsꍇ͐ڑs̎wsA
// TRISxœ͂ɐݒ肵܂As̓vAbvR{܂B
// J[h\Pbgɑ}mpsꍇ́A"sd_spi_config.h"ɋLqėL
// "FILEIO_SD_CONFIG_MEDIA_SOFT_DETECT"Lɂ܂A\tgoolɂȂ܂B
#define  SDSPI_CD_PIN   PORTBbits.RB0  // SDJ[h̃J[h}m(CD)s

// SDJ[hWP(CgveNgm)zꍇ͉LdefineRgɂāAڑs̎ws܂B
#define  SDSPI_CONFIG_WP_DISABLE
// CgveNgmsꍇ͐ڑs̎wsA
// TRISxœ͂ɐݒ肵܂As̓vAbvR{܂B
#define  SDSPI_WP_PIN   PORTBbits.RB5  // SDJ[h̃CgveNgm(WP)s

// SPISDJ[hZNgs̎wsATRISxŏo͂ɐݒ肵܂B
#define  SDSPI_CS_PIN   LATCbits.LATC2  // SDJ[h̃ZNg(CS)s


// SDJ[hSPIŎgps\ŋLq܂B
// PIC18F26K22MSSP1/MSSP22L邪ASD-SPIŎgp邩"drv_spi_config.h"ɋLڂ
// AAMSSP1MSSP2̉̂ݗp\łB
void USER_SdSpiConfigurePins (void)
{
     // `bvZNgsHIGH(Do not assert)ɃZbg
     SDSPI_CS_PIN = 1 ;
}

// SDJ[hZNgs
inline void USER_SdSpiSetCs(uint8_t a)
{
     SDSPI_CS_PIN = a ;
}

// J[h}ms
inline bool USER_SdSpiGetCd(void)
{
     return (!SDSPI_CD_PIN) ? true : false ;
}

// CgveNgos
inline bool USER_SdSpiGetWp(void)
{
#if defined (SDSPI_CONFIG_WP_DISABLE)
     return false ;
#else
     return (SDSPI_WP_PIN) ? true : false ;
#endif
}

/*******************************************************************************
sdCardMediaParameters\̂́A
SD-SPIt@ChCoɂĕKvƂ郆[Ů֐`܂B
hCo[́AKvȎɂĂяo܂B
SD-SPIhCȍꍇA[ÚAǂSPIW[gp邩`p[^/@\A
`bvZNgs̃Zbg/NAAJ[ȟoяݕیs̃Xe[^X̎擾A
CSsACDsAWPs̓o͂̐ݒiYꍇj
gpĂ}CNRg[ɂċ@\ςׁA̋@\system.cɎĂ܂B
[U[w肳ꂽhCuɃANZXꍇ́A̍\ێKvL܂B
*******************************************************************************/
FILEIO_SD_DRIVE_CONFIG sdCardMediaParameters =
{
    1,                        // Use SPI module 1
    USER_SdSpiSetCs,          // SDJ[h̃ZNgsZbg/NÃׂ[Uwt@NV
    USER_SdSpiGetCd,          // J[hos̃Xe[^X擾邽߂̃[Uw̃t@NV
    USER_SdSpiGetWp,          // CgveNg[q̏Ԃ擾邽߂̃[Uw̃t@NV
    USER_SdSpiConfigurePins   // sTRISrbg\邽߂̃[U[w̃t@NV
};